% 1. Adott az alabbi folytonos folyamat: A=..., b=..., c=..., d=...
% a. Adja meg a rendszer polusait es atviteli fuggvenyet! Stabilis-e a rendszer?
 p = eig(A); P = ss(A,b,c,d); Pzpk = zpk(P)
 % Ha p elemei negativak, stabil.

% b. Tervezzen allapotvisszacsatolasos szabalyozast ugy, hogy a zart rendszer egy masodrendu lengo tag es egy egytarolos tag soros eredoje legyen.
% A masodrendu lengo tag csillapitasi tenyezoje kszi, es idoallandoja T0 legyen! Az egytarolos tag idoallandoja legyen T1.
% Hatarozza meg az alapjelkoveteshez a kr statikus kompenzacios tenyezo erteket is!
den=[T0*T0,2*T0*kszi,1]; % kell
pc=roots(den); % kell
pc(3)=-1/T1; % ha van T1
k=acker(A,b,pc); % kell
kr=1/dcgain(A-b*k,b,c,d); % kell

% b./2 Tervezzen allapotvisszacsatolasos szabalyozast ugy, hogy a zart rendszer egy masodrendu lengo tag es egy egytarolos tag szorzata legyen.
% A masodrendu lengo tag csillapitasi tenyezoje kszi, es idoallandoja T0 legyen! Az egytarolos tag pólusa -5 legyen.
% Hatarozza meg az alapjelkoveteshez a kr statikus kompenzacios tenyezo erteket is! Adja meg a zart rendszer polusait! Abrazolja a rendszer atmeneti fuggvenyet (ugrasvalaszat)!
 T0 = ..
 kszi=.., T3=0.2, den = [T0*T0, 2*T0*ksz, 1]
 pc=roots(den), pc(3)=-1/T3
   den = [..] % eredmeny
   pc = [..] % eredmeny
 k = acker(A,b,pc), kr=1/dcgain(A-b*k,b,c,d)
 T = ss(A-b*k, b*kr, c, d), step(T), grid
   k = [..] % eredmeny

% c. Egysegugras bemenet es es zerus kezdeti ertek mellett abrazolja a visszacsatolt rendszer ugrasvalaszat es allapottrajektoriajat.
T=ss(A-b*k,kr*b,c,d);
[y,t,x]=step(T);
figure(1),plot(t,y),grid
figure(2),plot(x(:,1),x(:,2)),grid

% +. Iranyithato-e es megfigyelheto-e a rendszer?
rank(ctrb(A,b));
% Ha egyenlo A sorainak szamaval, iranyithato.
rank(obsv(A,b));
% Ha egyenlo A sorainak szamaval, megfigyelheto.

% ++. abrazolja a rendszer allapottrajektoriajat x0=... kezdeti feltetel eseten.
T=ss(A,b,c,d); % ha nincs t-s kszi-s szarsag
T=ss(A-b*k,kr*b,c,d); % ha van
x0=[...;...;...] % ha x0-nak 3 ertek van megadva, de ez alt csak 2
[y,t,x]=initial(T,x0); 
plot(x(:,1),x(:,2)),grid

% +++. Vegezzen allapottranszformaciot ugy, hogy az A matrix diagonalis legyen (kanonikus alak). Adja meg ebben az esetben az allapotmatrixokat.
[Ad,bd,cd,dd]=canon(A,b,c,d)
H=ss(A,b,c,d)
H=zpk(H)
eig(A)
 
% ++++. abrazolja a visszacsatolt rendszer ugrasvalaszat.
T=ss(A-b*k, kr*b, c, d)
step(T)
grid

% I. Egy folytonos szakasz atviteli fuggvenye P(s)=(csak valos resz). u(t) = sin(wt) gerjesztes eseten a kimeneti jel allandosult allapotbeli valasza
% u{t) = A sin(t + fi). Adja meg A es fi erteket.

s=zpk('s');
P=..
w=..
[a,fi]=bode(P,w)
A=2*a	% a 2 nem tuti

% II. Egy folytonos szakasz atviteli fuggvenye P(s)=(valos resz)*e^(-t*s). u(t) = 3*sin(w*t) gerjesztes eseten a kimeneti jel allandosult allapotbeli valasza
% u{t) = A sin(2*t + fi). Adja meg A es fi erteket.

s=zpk('s');
P=..			% csak az valos resz
w=..			% u(t)-bol
Td=..			% kepzetes resz -t-jebol a t
[m,f]=bode(P,w)
fi_delay=-w*Td*180/pi
A=3*m			% feladat beli u(t) 3-as szorzoja (nem tom minek)
fi=f+fi_delay

% III. Egy folytonos szakasz atviteli fuggvenye P(s)=(valos) )*e^(-t*s). u(t) = 2*sin(wt) bemenojel eseten allandosult allapotban a kimenojel y{t) = A*sin(w*t + fi).
% Hatarozza meg A, w, fi parameterek erteket!

s=zpk('s');
P=..		% csak a valos resz
w=..		% u(t)-bol
Td=..		% kepzetes resz -t-jebol a t
[m,fi]=bode(P,w)
A=2*m		% u(t)-bol
fid=fi-Td*w*180/pi

% IV. Egy folytonos szakasz atviteli fuggvenye P(s)=(valos resz)*e^(-t*s). u(t) = 2*sin(wt) gerjesztes eseten a kimeneti jel allandosult allapotbeli valasza
% y{t) = A*sin(t + fi). Hatarozza meg A es fi parameterek erteket!

s=zpk('s');
P=..
w=..		% u(t)-bol
Td=..		% kepzetes resz -t-jebol a t
[m,f]=bode(P,w)
A=2*m		% u(t)-bol
fi=f-Td*w*180/pi

% V. Egy folytonos szakasz atviteli fuggvenye P(s)=(valos resz)*e^(-t*s). u(t) = 10*sin(2t) bemenojel eseten allandosult allapotban a kimenojel y{t) = A*sin(w*t + fi).
% Hatarozza meg A, w es fi parameterek erteket! (6 pont)

s=zpk('s');
P=..
Td=..
w=..
[m,fi]=bode(P,w)
fid=fi-Td*w*180/pi
A=10*m		% u(t)-bol

% 1. Egy folytonos szakasz atviteli fuggvenye P(s) = P1(s) * e^(-Td*s). Az u(t) = Au*sin(w*t) bemenojel eseten allandosult allapotban a kimenojel y(t) = A*sin(w*t+fi).
% Hatarozza meg az A, w, fi parameterek erteket!
s=zpk('s');
[m,fi1]=bode(P1,w);
fid=-Td*w*180/pi; % kell
fi=fi1+fid; % kell
A=Au*m; % kell

% +. Egysegugras gerjesztes eseten adja meg a kimeneti jel analitikus kifejezeset!
Y=P/s;
[num,den]=tfdata(Y, 'v');
[r,p,k]=residue(num,den);
% y(t) = r1*e^p1*t + r2*e^p2*t + ...

% ++. u(t) = Au*sin(w0*t) = gerjesztes eseten a kimeneti jel allandosult allapotbeli valasza y(t)=Ay*sin(w0*t+fi). Adja meg az A , w0 es a fi erteket! 
[M,fi]=bode(P,w0);
A=Ay/M;

% 2. Adott az alabbi szabalyozasi kor: C(s) - yz(t) - P(s)
% a. Adja meg a poluskiejteses PIPD szabalyozo atviteli fuggvenyet, ha a PD tag poluseltolasi aranya X es az erositesi tenyezoje kc = ...
s=zpk('s');
P=..;
A=legnagyobb_s_elotti_szorzo_a_nevezoben;
B=masodik_legnagyobb_s_elotti_szorzo_a_nevezoben;
C=kc * (1+A*s)/(A*s) * (1+B*s)/(1+(B/X)*s);

% b. Adja meg a rendszer erositesi tartalekat es modulus tartalekat! Stabilis-e a zart rendszer?
L=C*P;
L=minreal(L);
[gm,pm]=margin(L);
m=bode(L+1);
mt=min(m);
% Ha pm, gm es mt nagyobb 0-nal, stabil.

% c. r(t) = 0 es yz(t) = dirac(t), t>=0 zavarojel eseten abrazolja minosegileg helyesen az y(t) kimenojel idobeli lefolyasat (Tn)! Adja meg a beavatkozojel kezdeti es vegerteket!
Tn=minreal(P/(1+L)); % ha C-yz-P
Tn=minreal(1/(1+L)); % ha C-P-yz
impulse(Tn),grid
u=minreal(-L/(1+L)); % ha C-yz-P
u=minreal(-C/(1+L)); % ha C-P-yz
impulse(u)
u=impulse(u);
u(0)
u(end)

% +. r(t)=0, yz(t)=1(t) => y(t) kimenojel idobeli lefolyasat (Tn)! Adja meg a beavatkozojel kezdeti es vegerteket!
u=minreal( -C/(1+L) ), step(u),grid


% 1. Adott az alabbi szabalyozasi kor: C(s)=k*C1(s), P(s)=...
% a. k=... eseten adja meg a rendszer fazistartalekat es erositesi tartalekat. Stabilis-e a zart rendszer? Adja meg k maximalis erteket, amelyre a rendszer meg stabilis!
s=zpk('s');
L1=minreal(k*C1*P);
[gm,pm]=margin(L1);
kmax=gm;
% Ha gm es pm nagyobb 0-nal, stabil.

% b. k=... Dirac impulzus zavarojelre zerus alapjel mellett abrazolja minosegileg helyesen az y kimenojel idobeli lefolyasat.
C=k*C1;
L=minreal(C*P);
[gm,pm]=margin(L);
Tz=P/(1+L); % ha C-yz-S
Tz=1/(1+L); % ha C-S-yz
Tz=minreal(Tz);
figure(2),impulse(Tz),grid % impulse helyett step ha dirac helyett egysegugras van

% c. r(t)=e^(-Td*t) es yz=0, 0<=t<=20 eseten abrazolja minosegileg helyesen az r(t) referencia jelet es az y(t) kimenojelet egy koordinata rendszerben.
T=minreal(L/(1+L));
t=0:0.05:20;
u=exp(-Td*t);
y=lsim(T,u,t);
plot(t,u,t,y),grid

% 4. Egy iranyitando szakasz atviteli fuggvenye P(s)=P1(s) * e^(-Td*s) A szakaszt Ts=... mintaveteli idovel mintavetelezzuk, bemeneten zerusrendu tartoszervet alkalmazunk.
% Az alapjel kovetesi dinamikajat eloiro Rr impulzusatviteli fuggveny az T1 atviteli fuggveny mintavetelezesevel,
% a zavarelharitast eloiro Rn impulzusatviteli fuggveny az T2 atviteli fuggveny mintavetelezesevel adodik.
s=zpk('s');
P1= ..
Ts= ..,
Td= ..,
d= Td/Ts,
% a./1 Adja meg a szakasz impulzusatviteli fuggvenyet!
 s=zpk('s');
 G1=c2d(P1,Ts);
 z=zpk('z',Ts);
 G=G1/(z^d); % eredmeny

% a./2 Adja meg a szakasz Rr, Rn impulzusatviteli fuggvenyeit.
s=zpk('s');
G1=c2d(P1,Ts);
z=zpk('z',Ts);
Td=1;
d=Td/Ts; G=G1/z^d; % ha van e^fos, ha nincs akkor G=G1
Rr=c2d(T1,Ts);
Rn=c2d(T2,Ts);

% b. Adja meg a szakasz G=G+*G_z^-d felbontasat.
A=G_szamlalojaban_a_(z+x)_tagbol_az_x
Gm=(z+A)/z;
Gm=Gm/dcgain(Gm);
Gp=minreal(G1/Gm,0.001);

% c. Adja meg a Q Youla parametert es a C szabalyozot.
Q=minreal(Rn/Gp); % eredmeny
C=minreal(Q/(1-Q*G)); % eredmeny
L=minreal(C*G);

% d. Vazolja ... egysegugras_alapjelre a kimenojel lefolyasat.
T=minreal(Rr/Rn*L/(1+L));
figure(1),step(T),grid

% e. Vazolja ... egysegugras_kimeneti_zavarasra es zero alapjelre a kimenojel lefolyasat.
Tyz=minreal(1/(1+L));
figure(2),step(Tyz),grid

% +. Vazolja fel minosegileg helyesen egy koordinatarendszerben a zart rendszer és az alapjel kovetesi referencia modell ugrasvalaszat. Mi okozza az elterest a ket jel kozott?
% Adja meg a beavatkozo jel maximalis erteket!
 L=minreal(C*G);
 T=minreal(Rr/Rn*L/(1+L));
 Uz=minreal((Rr/Rn)*Q), umax=max(step(Uz))
 figure(1), step(T, Rr), grid
 umax = ... % eredmeny
 A fo kulonbseg a ket jel kozott a holtidos tag es a Gm altal okozott kesleltetes.

% +. Adja meg a beavatkozo jel maximalis erteket.
uz=minreal(Rr/Rn*C/(1+L));
umax=max(step(uz))

% ++. Rr impulzusatviteli fuggvenyt szarmaztassuk... idoallando=T0, csillap: kszi
Rrs=1/(T0*T0*s*s+2*t0*kszi*s+1)
%d:
T=minreal(Rr/Rn*L/(1+L));
figure(1),step(T*Rrs),grid

% 3. Egy mintaveteles szabalyozasi korben a szaksz atviteli fuggvenye P(s)=P1(s)*e^(-(Td)*s). A mintavetelezesi ido: Ts=...
% a. Zerusrendu tartoszerv eseten adja meg a szakasz G(z) impulzusatviteli fuggvenyet zerus-polus alakban.
Td=
Ts=
P1=
s=zpk('s');
d=Td/Ts;
z=zpk('z',Ts);
G1z=c2d(P1,Ts);
Gz=G1z/(z^d);

% b. Tervezzen soros PID kompenzacio poluskiejtessel. A PD tag legyen idealis. A szabayozo aranyos tagja legyen XX. Adja meg a szabalyozo impulzusatviteli fuggvenyet zerus-polus alakban.
% Stabilis-e a diszkret zart rendszer? abrazolja a diszkret zart szab rendszer ugrasvalaszat.
A=Gz_nevezojeben_a_legnagyobb_z-bol_kivont_ertek;
B=Gz_nevezojeben_a_masodik_legnagyobb_z-bol_kivont_ertek;
Cz=XX*(z-A)*(z-B)/(z*(z-1));
Lz=minreal(Gz*Cz,0.001);
[gm,pm]=margin(Lz);
Tz=minreal(Lz/(1+Lz));
step(Tz),grid

% c. A szabalyozo impulzusatviteli fuggvenye C(z) = 0.5*( (z-z_1)/z ). Stabilis-e a diszkret zart rendszer? A diszkret zart szabalyozasi korben adja meg a
% beavatkozojel erteket az elso MINTA mintaveteli pontban egysegugras alapjel eseten.
MINTA=
Cz=0.5*(z-z1)/z
Lz=minreal(Cz*Gz, 0.001)
margin(Lz)
Uz=Cz/(1+Lz)
Uz=minreal(Uz, 0.001)
ud=step(Uz, Ts*MINTA)
%Stabilis, ha fazistartalek > 0

% d. Stabilis-e a diszkret zart rendszer? abrazolja a zart diszkret rendszer ugrasvalaszat. Adja meg a beavatkozo jel kezdeti es vegerteket. (Cz kell hozza)
Lz=minreal(Cz*Gz, 0.001)
[gm,pm]=margin(Lz) % erositesi tartalek es fazis tartalek erteke gm,pm
% ugrasvalasz:
Tz=Lz/(1+Lz)
figure(2)
step(Tz)
grid
% beavatkozo jel: u(0) es u(vegtelen erteke) kell
Uz=Cz/(1+Lz)
Uz=minreal(Uz, 0.001)
figure(3)
step(Uz)
grid

% +. milyen szabalyozo
%
% ha ilyen alaku : idealis PD-szabalyozo
 %     0.1152 (z+0.9201)
 %    --------------------
 %    z^2 (z-1) (z-0.7788)
 % z1=0.7788

% ha ilyen alaku : PI szabalyozo
 %       0.13417 (z+0.8008)
 %    -------------------------
 %    z^2 (z-0.8465) (z-0.6065)
 % z1=0.8465

% 2. Egy szakasz atviteli fgv-e P(s)=P1(s)*e^(-Td*s). Egy soros szabalyozasi korben a szabalyozo atviteli fuggvenye C(s)=...
% a. Hatarozzuk meg a szabalyozasi rendszer fazistartalekat, erositesi tartalekat Td=0 eseten.
s=zpk('s');
L=C*P1;
L=minreal(L);
[gm,pm]=margin(L);

% b. Td = 5 eseten hogyan valtozik a fazistartalek?
fid= -wc*Td*180/pi;
ft=pm+fid;

%Adott az alabbi szabalyozasi kor:
%C(s)=(1+5*s)/s P(s)=1/((1+5*s)*(1+s)*(1+0.2*s))
% a./ Adja meg a rendszer vagasi korfrekvenciajat, fazistartalekat es erositesi tartalekat. Stabilis-e a zart rendszer egysegugras zavarojelre es zerus alapjel eseten.
s=zpk('s')
 C=(1+5*s)/s
 P=1/((1+5*s)*(1+s)*(1+0.2*s))
 L=C*P
 L=minreal(L)
 figure(1)
 margin(L)
 %  Gm=15.6dB
[gm,pm,wg,wc]=margin(L)
 %  gm=6, pm=43.2099, wc=0.7793rad/sec
% Mivel pm>0, a szabalyozas stabilis.
% a./ Adja meg a rendszer fazistartalekat, erositesi tartalekat es modulus tartalekat. Stabilis-e a zart rendszer?
 L=C*P
 L=minreal(L)
 figure(1)
 margin(L)
 [gm,pm]=margin(L)
 m=bode(L+1)
 mt=min(m)
%  gm= 30 (29.5dB), pm=81.48, mt=0.89, stabilis (pm>0)



% a./ Hatarozza meg K maximalis erteket, amelynel a zart rendszer meg stabilis!
s=zpk('s')
 P= 1/( (1+s)*(1+5*s) )
 C=3*(1+5*s)/(5*s)
 L=C*P
 L=minreal(L)
 kmax = margin(L)
% strukturalisan stabilis, kmax=inf

% 1. Egy zart szabalyozasi kor felnyitott korenek atviteli fuggvenye L(s)= ..
% a. Adja meg K max > 0 erteket, amely mellett a zart kor meg stabilis!
s=zpk('s'), L1=.., kmax(margin(L1)

% b./ Hatarozza meg azt a K erteket, amely mellett a rendszer fazistartaleka 65 fok!
 [m,f,w]=bode(L)
 kc = margin(m,f-65,w)

% c./ K =0.1 és r(t)=e^(-0.2t) alapjel eseten abrazoljuk a kimeneti jelet a 0<= t <= 100sec időtartományban!
 L1 = 0.1*L
 T = L1/(1+L1)
 T = minreal(T)
 t = 0:0.1:100
 r = exp(-0.2*t)
 y = lsim(T,r,t)
 plot(t,r,t,y); grid


 % b./ Abrazolja minosigileg helyesen az y kimenojel idbeli lefolyasat, c./ Adja meg a kimenojel es a beavatkozojel allandosult erteket.
Tz=P/(1+L)
 Tz=minreal(Tz)
 figure(2)
 step(Tz)
 grid
% y_veg=0,
 % u_veg=-1

% K=3 mellett: b./ adja meg a rendszer erositesi tartalekat, fazistartalekat es modulus tartalekat. Stabilis-e a zart szabalyozasi rendszer?
[gm,pm]=margin(L)
 m=bode(L+1);
 mt=min(m)
 %  pm=62, mt=0.76, stabilis
% r(t) = 0 es y_z(t) = 1(t) eseten abrazolja minosegileg helyesen az y(t) kimenojel idbeli lefolyasat. Jelolje be az abran a fontosabb ertekeket (kezdeti ertek, vegertek, beallasi ido)
H=minreal(1/(1+L))
 step(H)
 grid on
% r(t) = e^(-2t) es y_z(t)=0 eseten abrazola minosegileg helyesen  az y(t) kimenojel idobeli lefolyasat.
T=minreal(L/(1+L))
 R=1/(s+2)
 impulse(R,T*R)
 grid
 % Ebben az esetben (fi = .. fok) abrazolja a kimenojelet es a beavatkozo jelet! Jelolje be az abrakon a fontosabb ertekeket!
 C=C1*k, L=minreal(C*P)
 T=minreal(L/(1+L)); figure(1), step(T), grid
 U=minreal(C/(1+L)); figure(2), step(U), grid

% Egy soros szabalyozasi korben a szakasz ket idoallandoja 10 es 5 sec.
% a./ adja meg a poluskiejteses diszkret PI szabalyozo impulzusatviteli fuggvenyet. A szabalyozo aranyos tagja legyen kc=1. A mintaveteli ido Ts=1 sec.
 Ti=10, Ts=1, zi=exp(-Ts/Ti), kc=1
 C = kc*(z-zi/(z-1))

% b./ A diszkret szabalyozo impulzusatviteli fuggvenye alapjan adja meg az azt megvalosito algoritmust (differenciaegyenlet).
 (z-zi)/(z-1) = (1-zi*z^-1)/(1-z^-1) = U(z)/E(z)

% c./ Irjon Matlab programot a szabalyozo algoritmus megvalositasara. Az algoritmus szamolja ki a szabalyozo ugrasvalaszat (atmeneti fuggvenyet) az elso 10 mintaveteli pontban.
 zi=exp(-0.1)
 N=10; e(1:N)=1; u(1)=0+1-0*zi;
 for k=2:N
    u(k)=u(k-1)+e(k)-e(k-1)*zi
 end
 step(u), grid % jo: stairs(u), plot(u, '*')

% Egysegugras zavarojel es zerus alapjel (r(t) = 0 es y_z(t) = 1(t)) eseten b./ Abrazolja minosegileg helyesen az y kimenojel idobeli lefolyasat
% c./ Adja meg a bevatkozo jel kezdeti es allandosul erteket.
U=minreal(-C/(1+L))
 step(U)
 grid
 % u_kezd = -1
 % u_veg = -0.1
% r(t) = 0 es 0<=t<=100 (sebessegugras) alapjel es zerus zavaras eseten abrazolja minosegileg egy koordinata-rendszerben az alapjelet es a kimeno jelet! Mekkora a statikus hiba?
T=minreal(L/(1+L))
 R=1/(s*s)
 impulse(R,T*R,30)
 grid
 %vagy:
t=0:0.1:30;
 r=t;
 y=lsim(T,r,t);
 plot(t,r,t,y)
 grid
%mego.:
 % es=1/K=1/0.5=2

%Egy iranyitando szakasz atviteli fuggvenye: P(s)= =1/(1+8*s). A szakaszt T_s=1 sec mintaveteli idovel mintavetelezzuk, bemeneten zerusrendu tartoszervet alkalmazunk.
% Tervezzen Youla parametrizalt szabalyozot az alabbi feltetelekkel: G_-=1 (a szakasz dinamikaja a szabalyozoval kiejtheto), alakjel kovetesi dinamikajat eloiro R_r 
%impulzusatviteli fuggveny az 1/(1+s) atviteli fuggveny mintavetelezesevel, a zavarelharitasi eloiro R_n impulzusetviteli fuggveny az 1/(1+s) atviteli fuggveny mintavetelezesebol adodik.
clear
 s=zpk('s')
 P=1/(1+8*s)
 Ts=1
% a./ Adja meg a szakasz es a szurok impulzusatviteli fuggvenyeit.
G=c2d(P,Ts)
 z=zpk('z',Ts)
 Gm=1
 Gp=G*z
 display(' Rr ='), Rr=c2d(1/(1+s), Ts)
 display(' Rn ='), Rn=c2d(1/(1+s), Ts)
% b./ Adja meg a Q Youla parametert.
display(' Q ='),  Q=minreal(Rn/Gp)
% c./ Adja meg a Youla parametrizalt C szabalyozot.
display(' C ='),  C=minreal( (Rn/Gp)*(1/(1-Rn*Gm*z^(-1))) )
% d./ vazolja fel minosegileg helyesen a kimeno jel lefolyasat. Mennyiben ter ez el az R_r szuro kimenojeletol?
L=minreal(C*G)
 T=minreal( (Rr/Rn)*L/(1+L) )
 figure(1)
 step(Rr,T)
 grid
% e./ Mekkora a beavatkozojel maximalis erteke?
[u,t]=step((Rr/Rn)*Q)
 umax=max(u)
 figure(2)
 stairs(t,u)
 grid
% f./ Egysegugras kimeneti zavarojelre mekkora a kimenojel kezdeti es vegerteke?
A kimeneti zavaras hatasara a kimenojel kezdeti erteke 1, vegerteke 0, dinamikajat R_n hatarozza meg.
 %disturbance
 Sn=( 1-Rn*Gm*z^(-1) )
 figure(3), step(Sn), grid
 figure(4), step(-Q, 10), grid

%Egy iranyitando szakasz atviteli fuggvenye: P(s)=( 1/((1+5*s)*(1+10*s)) )*e^(-2*s). A szakaszt T_s=2 sec mintaveteli idovel mintavetelezzuk,
% bemeneten zerusrendu tartoszervet alkalmazunk. Tervezzen Youla parametrizalt szabalyozot egysegnyi alapjel es zavarojel szuro feltetelezesevel (R_r=1; R_n=1)
clear
 s=zpk('s')
 P1=1/((1 +5*s)*(1+10*s) )
 Ts=2
 G1=c2d(P1,Ts)
 z=zpk('z',Ts)
 G=G1/z
 
 d=2
%  a./ Adja meg a szakasz impulzusatviteli fuggvenyet. Adja meg a szakasz felbontasat. (G_+, G_- es d kifejezeet a G=( G_+*G_-*z^(-d) ) felbontasban). 
display(' Gm ='), Gm=((z+0.8187)/( 1+0.8187))*z^(-1)
 display(' Gm ='), Gp=minreal(G/Gm/(z^(-d)), 0.001)
 Rr=1;
 Rn=1;
% b./ Adja meg a Q Youla parametert.
display(' Q ='),  Q=minreal(Rn/Gp)
% c./ Adja meg a Youla parametrizalt C szabalyozot.
display(' C ='),  C=minreal( Q/(1-Q*G) )
% d./ vazolja fel minosegileg helyesen a kimeno jel lefolyasat. Mennyiben ter ez el az R_r szuro kimenojeletol?
L=minreal(C*G)
 T=minreal( (Rr/Rn)*L/(1+L) )
 figure(1)
 step(T)
 grid
% e./ Mekkora a beavatkozojel maximalis erteke?
[u,t]=step((Rr/Rn)*Q)
 umax=max(u)
 figure(2)
 stairs(t,u)
 grid

% Egy iranyitando szakasz atviteli fuggvenye: P(s)=( 1/((1+2*s)*(1+10*s)) )*e^(-2*s). A szakaszt T_s=2 sec mintaveteli idovel mintavetelezzuk,
% bemeneten zerusrendu tartoszervet alkalmazunk. Tervezzen Youla parametrizalt szabalyozot R_r=1/z; R_n=1/z feltetelezesevel.
%a./ Adja meg a szakasz impulzusatviteli fuggvenyet
clear
 s=zpk('s')
 P1=( 1/((1+2*s)*(1+10*s)) )
 Ts=2
 Td=2
 d=Td/Ts
 G1=c2d(P1,Ts)
 z=zpk('z',Ts)
 G=G1/(z^d)

% b./ Adja meg a szakasz felbontasat (G_+, G_- es d kifejezeset a G=( G_+*G_-*z^(-d) ) felbontasban).
Gm=(z+0.6714)/z
 Gm=Gm/dcgain(Gm)
 d=1
 Gp=minreal(G/(Gm*z^(-d)), 0.001)

% c./ Adja meg a Q Youla parametert es a Youla parametrizalt C szabalyozot.
Rr=1/z;
 Rn=1/z;
 Q=minreal(Rn/Gp)
 C=minreal( Q/(1-Q*G) )
 
 % d. Vazolja fel minosegileg helyesen egy koordinatarendszerben a zart rendszer es az alapjel kovetesi referencia modell ugrasvalaszat.
 % Mi okozza az elterest a ket jel kozott?
 L=minreal(C*G), T= minreal( (Rr/Rn)*L/(1+ L) ),
Uz= minreal ((Rr/Rn)*Q), umax=max(step(Uz))
figure(1), step( T, Rr),grid, 
% VALASZ: A fo kulonbseg a ket jel kozott a holtidos tag es a Gm altal okozott kesleltetes.